/*
 * last modified : 21/09/27
 *
 * Hidetada Baba (RIKEN)
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "libskelgto.h"
#include "cmdskelgtofunc.h"

COMMAND comlist[] = {
  {"read",      read,      "Read parameters (for debug)", NULL},
  {"uread",     uread,     "Read parameters (for debug)", NULL},
  {"init",      init,      "Initialize all parameters to default value", NULL},
  {"eepr",      eepr,      "Load parameters from EEPROM", NULL},
  {"eepw",      eepw,      "Save current parameters to EEPROM", NULL},
  {"val",       val,       "Set value to the resister", "address[0-63] value"},
  {"uval",      uval,      "Set user value to the user register", "address[0-63] value"},
  {"noop",      noop,      "Dummy access to GTO", NULL},
  {"help",      help,      "Help", NULL},
  {NULL,        NULL,      NULL,   NULL} };

void quit(void){
  gto_close();
}

int main(int argc, char *argv[]){
  int i;

  if(argc < 3){
    help();
    return 0;
  }

  if(!gto_open(argv[1])){
    printf("Cannot connect %s\n", argv[1]);
    return 0;
  }

  gto_flush();

  i=0;
  while(comlist[i].com != NULL){
    if(!strcmp(comlist[i].com, argv[2])){
      if(!comlist[i].func(argv+3)){
	printf("Invalid argument %s\n\n", argv[3]);
	help();
      }
      break;
    }
    i++;
  }

  if(comlist[i].com == NULL){
    printf("Invalid function %s\n\n", argv[2]);
    help();
  }else{
    noop();
  }


  quit();

  return 0;
}
