/* functions */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include "libskelgto.h"
#include "cmdskelgtofunc.h"
#include "cmdskelgto.h"

extern COMMAND comlist[];

char data[64] = {0};
char t[256] = {0};

const char *ofstr[] = {"off\0", "on\0"};

void showsel(long long int val);

char *findparam(char ena, SDGTOADVLL *adv){
  int i = 0;

  while(adv[i].param){
    if(ena == adv[i].val){
      return adv[i].param;
    }
    i++;
  }
  
  return NULL;
}

int chkupper(char c){
  if(isupper(c)){
    return 1;
  }else{
    return 0;
  }
}

int chkone(char c){
  if(c == '1'){
    return 1;
  }
  return 0;
}

long long int chkvalll(char *arg, SDGTOADVLL *adv){
  int i=0;
  while(adv[i].param){
    if(!strcmp(adv[i].param, arg)){
      return adv[i].val;
    }
    i++;
  }

  return -1;
}

int chkval(char *arg, SDGTOADV *adv){
  int i=0;
  while(adv[i].param){
    if(!strcmp(adv[i].param, arg)){
      return adv[i].val;
    }
    i++;
  }

  return -1;
}

char chkadv(char *arg, SDGTOADVLL *adv, SDGTOADVLL *radv){
  int i=0;
  while(adv[i].param){
    if(!strcmp(adv[i].param, arg)){
      memcpy((char *)radv, (char *)(adv+i), sizeof(SDGTOADVLL));
      return 1;
    }
    i++;
  }
  radv->param = NULL;
  radv->addr = -1;
  radv->val = -1;
  radv->disable = -1;
  return -1;
}

int noop(void){
  return gto_read(data);
}

int read(void){
  gto_read(data);
  gto_dumpdata(data);
  //gto_dumpcdata(data);
  return 1;
}

int uread(void){
  gto_uread(uadr_uread, data);
  gto_dumpdata(data);
  //gto_dumpcdata(data);
  return 1;
}

int init(void){
  printf("Initialize\n");
  return gto_reset();
}

int eepr(void){
  printf("Parameters from EEPROM\n");
  gto_eepread();

  gto_read(data);
  gto_dumpdata(data);
  //gto_dumpcdata(data);
  return 1;
}

int eepw(void){
  printf("Current parameters to EEPROM\n");
  return gto_eepwrite();
}


// Set val
int val( char *args[]){
  char adr, val;

  if(!args[0]) return 0;
  if(!args[1]) return 0;

  adr = (char)strtol(args[0], NULL, 0);
  val = (char)strtol(args[1], NULL, 0);

  if(adr < 0 || adr > 63){
    printf("invalid adr (%d), adr must be 0..63\n", (int)adr);
  }
  
  printf("\n");

  printf("set val : adr %d, val %d\n", (int)adr, (int)val);
  gto_write(adr, val);

  return 1;
}

// Set user val
int uval( char *args[]){
  char adr, val;

  if(!args[0]) return 0;
  if(!args[1]) return 0;

  adr = (char)strtol(args[0], NULL, 0);
  val = (char)strtol(args[1], NULL, 0);

  if(adr < 0 || adr > 63){
    printf("invalid adr (%d), adr must be 0..63\n", (int)adr);
  }
  
  printf("\n");

  printf("set user val : adr %d, val %d\n", (int)adr, (int)val);
  gto_uwrite(adr, val);

  return 1;
}


int pulse(char *args[]){
  unsigned char val;

  if(!args[0]) return 0;

  val = (unsigned char)strtol(args[0], NULL, 0);
  
  gto_uwrite(uadr_pulse, val);

  return 1;
}


int help(void){
  int i;
  printf(" cmdskelgto HOSTNAME COM [params] ...\n\n");
  printf(" COM = ");
  i = 0;
  while(comlist[i].com != NULL){
    printf(" %-8s : %s ", comlist[i].com, comlist[i].doc);
    if(comlist[i].param != NULL){
      printf("(%s)", comlist[i].param);
    }
    printf("\n       ");
    i++;
  }
  printf("\n");
	 

  return 1;
}
